
#include "INA3221.h"

INA3221::INA3221(uint8_t adr){
	this->adr = adr;

}

INA3221::INA3221(uint8_t adr, int channels, int average)
{
	this->adr = adr;
	config = 0b0000000100100111 | channels | average;
}

void INA3221::setup(){
	Wire.begin();
	Wire.beginTransmission(adr);
	Wire.write(0);
	Wire.write(highByte(config));
	Wire.write(lowByte(config));
	Wire.endTransmission();
}

float INA3221::shunt(uint8_t ch, int r){
	int mil = (read_int((ch * 2) - 1))>>1;
	return(float)mil *100 / r ; // millampers
}

int INA3221::bus(uint8_t ch){
	return read_int(ch * 2); // millivolts
}

int INA3221::read_int(uint8_t b){
	Wire.beginTransmission(adr);
	Wire.write(b);
	Wire.endTransmission();
	Wire.requestFrom(adr, uint8_t(2));
	int i = Wire.read() << 8;
	i |= Wire.read();
	return i;
}
